]> git.sesse.net Git - backup.sh/blobdiff - backup.sh
Be more consistent about ssh and scp options.
[backup.sh] / backup.sh
index c79432293d3aff1c8ff392bac8c2581d42193fae..7fc7ffb0018fecd951b3d64249637aa5ea28cc71 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
 # The script is halfway Norwegian and halfway English. Newer modifications are
 # in English, we should probably stick to that.
 
-# The computer to backup.
-computer=$1
-
-# Configuration
-LOCKFILE=/home/backup/backuprun.lockfile.$computer
-confdir=/home/backup/conf/              # Configuration files
-storagedir=/backup                      # Where we keep backups
-maxnumfull=3                            # Number of full backups
-daysbetweenfull=30                      # Days between full backups
-daysbetweenfullforfixed=32              # Days between full backups for machines with fixed
-                                        # full-backup date (in case the fixed day gets missed)
-DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
-DATE=`date "+%Y%m%d%H%M"`               #format: touch
-DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
-
-# Exclude-pattern
-exclude=$confdir/exclude
-[ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
+SCRIPTPATH="$( cd "$(dirname "$0")" ; pwd -P )"  # Absolute directory the script lives in
+confdir=$SCRIPTPATH/conf/                        # Directory configuration files
+[ -r $confdir/env ] && . $confdir/env
+
+# Default configuration; used unless $confdir/env has set something different.
+storagedir=${storagedir:-/backup}                # Where we keep backups
+exclude=${exclude:-$confdir/exclude}             # List of exclude patterns
+maxnumfull=${maxnumfull:-3}                      # Number of full backups
+daysbetweenfull=${daysbetweenfull:-30}           # Days between full backups
+
+# Days between full backups for machines with fixed full-backup date
+# (in case the fixed day gets missed).
+daysbetweenfullforfixed=${daysbetweenfullforfixed:-32}
+
+# End of configuration.
+
+computer=$1                                      # The computer to backup.
+LOCKFILE=$SCRIPTPATH/backuprun.lockfile.$computer
+DAY_OF_MONTH=`date "+%d" | sed s/^0//`           # from 1 to 31
+DATE=`date "+%Y%m%d%H%M"`                        # format: touch
+DATEs=`date "+%Y-%m-%d %H:%M"`                   # format: tar
 
 if [ -z "$computer" ]; then
        echo "Usage: $0 COMPUTER"
        exit 1
 fi
 
+[ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
+
 # Die more or less gracefully (at least notify user)
 die() {
        warnmsg "Aborting."
@@ -63,9 +68,10 @@ infomsg() {
 # Trap C-c and kill
 trap die SIGINT SIGTERM
 
-# Don't start if we're already running
+# Don't start if we're already running. Don't use diemsg, as that removes the lock file!
 if [ -e $LOCKFILE ]; then
-       diemsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
+       warnmsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
+       exit 1
 fi;
 touch $LOCKFILE
 echo $$ > $LOCKFILE
@@ -84,7 +90,7 @@ backup()
                # If incremental backup, we need to copy the incremental status to $computer.
                # If it does not exist, whine a bit and then run date-based instead.
                if [ -s "$localsnar" ]; then
-                       if ! scp $localsnar $username@$computer:$remotesnar; then
+                       if ! scp $localsnar $username@$computer:$remotesnar >&2; then
                                diemsg "Could not copy .incremental.snar to $computer"
                        fi
                        lastcmd="--listed-incremental=$remotesnar --no-check-device"
@@ -112,7 +118,7 @@ backup()
        #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
        #    file and build a file list, respectivly.  
        TARFILE=$DATE.tmp
-       TARCMD="ssh $username@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
+       TARCMD="ssh -n $username@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
                --exclude-from=$remotehome/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
        infomsg "Running $TARCMD"
        eval $TARCMD > $DATE.idx
@@ -121,7 +127,7 @@ backup()
                # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
  
                if [ "$remotesnar" ]; then
-                       if ! scp $username@$computer:$remotesnar $localsnar.tmp; then
+                       if ! scp $username@$computer:$remotesnar $localsnar.tmp >&2; then
                                diemsg "Could not copy .incremental.snar from $computer"
                        fi
                fi
@@ -140,7 +146,7 @@ backup()
                chmod 644 *idx 2>/dev/null          #everyone can read
 
                # Let the remote computer know that we ran a successful backup (for nagios)
-               ssh $username@$computer touch $filesystem/.lastbackup
+               ssh -n $username@$computer touch $filesystem/.lastbackup
        else
                # Something wrong happened.
                rm $TARFILE
@@ -153,24 +159,26 @@ backup()
 #  - No .idx files.
 #  - No .snar-style incremental backups, only date-based.
 #  - No touching of .lastbackup for Nagios.
+#  - Failed tar operations may go undetected, since we only see the error code
+#    the last process in the pipe chain, which is gpg.
 nonprivbackup()
 {
        infomsg "$computer:$filesystem $backuplevel non-privileged backup"
 
        if [ "$backuplevel" = "daglig" ]; then
                lastd=`cat ../.date`
-               lastcmd="\"$lastd\""
+               lastcmd="'$lastd'"
        else
                lastcmd=""
        fi
 
        TARFILE=$DATE.tmp
-       TARCMD="ssh $username@$computer \"sudo /usr/local/sbin/output-encrypted-backup $filesystem $lastcmd\""
+       TARCMD="ssh -n $username@$computer \"sudo /usr/local/sbin/output-encrypted-backup $filesystem $lastcmd\""
        infomsg "Running $TARCMD"
        eval $TARCMD > $TARFILE
 
-       if [ $? -lt 2 ] && [ -s $TARFILE ]; then
-               # File is >0 in size and the remote tar did not report any fatal errors; we assume it worked.
+       if [ $? -eq 0 ] && [ -s $TARFILE ]; then
+               # File is >0 in size and the remote side did not report any fatal errors; we assume it worked.
 
                # Move tar file in place
                mv $TARFILE $DATE.tgz.gpg
@@ -213,7 +221,7 @@ if ! ssh -n -o NumberOfPasswordPrompts=0 $username@$computer /bin/true; then
 fi
 
 # Find the home directory of the backup user
-remotehome=`ssh $username@$computer "echo ~"`
+remotehome=`ssh -n $username@$computer "echo ~"`
 if [ -z "$remotehome" ]; then
        diemsg "Could not expand ~ for user $username"
 fi
@@ -234,12 +242,12 @@ filesystems=`ssh -n $username@$computer "cat /etc/fstab" \
        | awk '{ if ( $(NF-1) != "0" ) print $2}' `
 
 # Clean up our dir at this client
-if ! ssh $username@$computer "rm -r $remotehome/.backup ; mkdir -m 700 $remotehome/.backup"; then
+if ! ssh -n $username@$computer "rm -r $remotehome/.backup ; mkdir -m 700 $remotehome/.backup"; then
        diemsg "Could not create backup staging area at $computer:$remotehome/.backup"
 fi
 
 # Try to copy $exclude to $computer
-if ! scp $exclude $username@$computer:$remotehome/.backup/exclude > /dev/null; then
+if ! scp $exclude $username@$computer:$remotehome/.backup/exclude >&2; then
        diemsg "Could not copy exclude.txt to $computer"
 fi
 
@@ -256,7 +264,7 @@ if [ -f $confdir/postexec.$computer ]; then
 fi
 
 # Try to run preexec if it exists
-if ! ssh $username@$computer "[ ! -f $remotehome/.backup/preexec ] || /bin/bash -x $remotehome/.backup/preexec" >&2; then
+if ! ssh -n $username@$computer "[ ! -f $remotehome/.backup/preexec ] || /bin/bash -x $remotehome/.backup/preexec" >&2; then
        diemsg "Could not run $computer:$remotehome/.backup/preexec"
 fi
 
@@ -332,7 +340,7 @@ for filesystem in $filesystems; do
 done
 
 # Try to run postexec if it exist
-if ! ssh $username@$computer "[ ! -f $remotehome/.backup/postexec ] || /bin/bash -x $remotehome/.backup/postexec" >&2; then
+if ! ssh -n $username@$computer "[ ! -f $remotehome/.backup/postexec ] || /bin/bash -x $remotehome/.backup/postexec" >&2; then
        diemsg "Could not run $computer:$remotehome/.backup/postexec"
 fi